import React from 'react';
import ReactDOM from 'react-dom';

class AXIS extends React.Component{

    constructor(props){
       super(props)
       this.renderD3Component = this.renderD3Component.bind(this)   
       Object.values(this.props)
      
    }
  
    renderD3Component(){
      
     // console.log(this)
       //ReactDOM.find(this).parent
       const axis  = AxisComponent(this.node)
       const margin = ReactDOM.findDOMNode(this).parentNode
       const svg = margin.parentNode
       const height = svg.getAttribute('height')
       const width = svg.getAttribute('height')
       console.log('svg',margin.getAttribute('transform'))
    }
  
    componentDidMount(){
        this.renderD3Component()
    }
  
    componentDidUpdate(){
        this.renderD3Component()
    }
  
    render(){
       return (<g ref = { node => this.node = node } >
          {this.props.children}
           {this.props.text}
           
       </g>);
    }
}

export default AXIS;

import { select, 
        arc,
        csv,
        scaleLinear,
        max,
        scaleBand,
        axisLeft,
        axisBottom,
        format,
        sum
       
       } from 'd3'

const AxisComponent = (selection,props) => {
      
    const render = (data) =>{
      drawAxis(data)
    }
    
    const drawAxis = (data)=>{
         
         selection = select(selection)
      
         const height = props.height
         const width = props.width
         
      
         const margin = { left:80,right:80,top:40,bottom:40}
         const innerWidth = width - margin.left - margin.right;
         const innerHeight = height - margin.top - margin.bottom;
      

         const xValue = d => d.value
         const yValue = d => d.label
      			
         const xScale = scaleLinear()
                        .domain([0,max(data,xValue)])
                        .range([0,innerWidth])
                        .nice();
      
         console.log('max for chart',max(data,xValue))
  
         const yScale = scaleBand().domain(data.map(yValue))
                                    .range([0,innerHeight])
                                    .padding(0.3);
      
         const xFormat = x => { return format("0.2s")(x)  } ;
  
         const yaxis = axisLeft(yScale); 
  
         const xaxis = axisBottom(xScale).tickFormat(xFormat);
      
         const axi = selection.selectAll('g').data([sum(data.map(d=>d.value))])
      
         const axisEnter = axi.enter()
         
  
         axisEnter.append('g')
                  .call(yaxis)
      
         axisEnter.append('g')
                  .call(xaxis) 
                  .attr('transform',`translate(0,${innerHeight})`)
    
      
     }
    
    return render;
 }


